using SewingDressesFileImplement.Models;
using System.Xml.Linq;

namespace SewingDressesFileImplement
{
    internal class DataFileSingleton
    {
        private static DataFileSingleton? instance;
        private readonly string ComponentFileName = "Component.xml";
        private readonly string OrderFileName = "Order.xml";
        private readonly string DressFileName = "Dress.xml";
        private readonly string ClientFileName = "Client.xml";
		private readonly string ImplementFileName = "Implement.xml";
        private readonly string MessageInfoFileName = "MessageInfo.xml";
		public List<Component> Components { get; private set; }
        public List<Order> Orders { get; private set; }
        public List<Dress> Dresses { get; private set;}
        public List<Client> Clients { get; private set; }
        public List<Implement> Implements { get; private set; }
        public List<MessageInfo> Messages { get; private set; }
        public static DataFileSingleton GetInstance()
        {
            if (instance == null)
            {
                instance = new DataFileSingleton();
            }
            return instance;
        }
        private static void SaveData<T>(List<T> data, string filename, string xmlNodeName, Func<T, XElement> selectFunction)
        {
            if (data != null)
            {
                new XDocument(new XElement(xmlNodeName, data.Select(selectFunction).ToArray())).Save(filename);
            }
        }
        private static List<T>? LoadData<T>(string filename, string xmlNodeName, Func<XElement, T> selectFunction)
        {
            if (File.Exists(filename))
            {
                return XDocument.Load(filename)?.Root?.Elements(xmlNodeName)?.Select(selectFunction)?.ToList();
            }
            return new List<T>();

        }
        public void SaveComponents() => SaveData(Components, ComponentFileName, "Components", x => x.GetXElement);
        public void SaveDresses() => SaveData(Dresses, DressFileName, "Dresses", x => x.GetXElement);
        public void SaveOrders() => SaveData(Orders, OrderFileName, "Orders", x => x.GetXElement);
        public void SaveClients() => SaveData(Clients, ClientFileName, "Clients", x => x.GetXElement);
        public void SaveImplements() => SaveData(Implements, ImplementFileName, "Implements", x => x.GetXElement);
        public void SaveMessages() => SaveData(Messages, MessageInfoFileName, "Messages", x => x.GetXElement);
		private DataFileSingleton()
        {
            Components = LoadData(ComponentFileName, "Component", x => Component.Create(x)!)!;
            Dresses = LoadData(DressFileName, "Dress", x => Dress.Create(x)!)!;
            Orders = LoadData(OrderFileName, "Order", x => Order.Create(x)!)!;
            Clients = LoadData(ClientFileName, "Client", x => Client.Create(x)!)!;
            Implements = LoadData(ImplementFileName, "Implement", x => Implement.Create(x)!)!;
            Messages = LoadData(MessageInfoFileName, "MessageInfo", x => MessageInfo.Create(x)!)!;
        }
    }
}
